<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services\CombinacaoProduto;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelCombinacaoProduto  {
    protected $combinacaoProduto;
    protected $utilService;
    
    public function __construct (CombinacaoProduto $combinacaoProduto, Utilities\Util $utilService){
        $this->utilService          = $utilService;
        $this->combinacaoProduto    = $combinacaoProduto;
    }
    
    public function findReport(Request\Filter $request, Response $response){
        $result = [];
        $conditions = $this->utilService->getParamsAsArray($request);
        
        if(isset($conditions['CDFILIAL']) && !empty($conditions['CDFILIAL'])) {
            
            if (isset($conditions['DTHRPEDIDO'])){
            $DTINI = $conditions['DTHRPEDIDO'][0];
            $DTFIN = $conditions['DTHRPEDIDO'][1];
            unset($conditions['DTHRPEDIDO']);
            }
            
            if (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'I'){
            if (empty($conditions['CDARVPRODF'])){
            $conditions['CDARVPRODF'] = $conditions['CDARVPRODI'];
            }
            $conditions['TCDPRODUTO'] = null;
            $conditions['CDPRODLIST'] = null;
            $conditions['PRODNIV'] = null;
            }elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'D') {
            $conditions['PRODNIV'] = str_replace('%', '', str_replace('.', '', $conditions['PRODNIV'])).'%';
            $conditions['TCDPRODUTO'] = null;
            $conditions['CDPRODLIST'] = null;
            $conditions['CDARVPRODF'] = null;
            $conditions['CDARVPRODI'] = null;
            }
            elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'L'){
            $conditions['CDPRODLIST'] = implode('_', $conditions['CDPRODUTO']);
            $conditions['TCDPRODUTO'] = null;
            $conditions['CDARVPRODF'] = null;
            $conditions['CDARVPRODI'] = null;
            $conditions['PRODNIV'] = null;
            }
            else{
            $conditions['TCDPRODUTO'] = 'T';
            $conditions['CDPRODLIST'] = null;
            $conditions['CDARVPRODF'] = null;
            $conditions['CDARVPRODI'] = null;
            $conditions['PRODNIV'] = null;
            }
            $resposta = $this->combinacaoProduto->getReport($conditions);
            $response->addDataSet(new DataSet("orm00020_relCombProd", $resposta));
        }
        
        return $result;
        
    }
    
}