<?php    
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelVendasGerenciais  {

    protected $RelVendasGerenciais;
    protected $utilService;
    
    public function __construct(Services\RelVendasGerenciaisService $RelVendasGerenciaisService, Utilities\Util $utilService) {
        $this->RelVendasGerenciaisService = $RelVendasGerenciaisService;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        try{
            $conditions = $this->utilService->getParamsAsArray($request);
            $conditions = $this->buildParams($conditions);
            $result = $this->RelVendasGerenciaisService->find($conditions, $conditions['IDRELATORIO']);
    
            $response->addDataSet(new DataSet("relVendasGerenciais", $result));
            return $response;
        }
        catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function buildParams($conditions){
        $conditions['CDFILIAL'] = isset($conditions['CDFILIAL']) ? implode('_', $conditions['CDFILIAL']) : '';
        $conditions['IDSITUVENDA'] = isset($conditions['IDSITUVENDA']) ? $conditions['IDSITUVENDA'] : 'T';

        if(array_key_exists('DTENTRVENDA', $conditions)) {
            $conditions['DTINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DTFIM'] = $conditions['DTENTRVENDA'][1];
            unset($conditions['DTENTRVENDA']);
        }
        
        return $conditions;
    }
    
}
