<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use \Zeedhi\Framework\Util\Functions;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class vendaProdutoPeriodoController {
    
    protected $vendaServices;
    
    public function __construct (Services\vendaProdutoPeriodoServices $vendaServices) {
        $this->vendaServives = $vendaServices;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $obrigatorios = ['TIPORELATORIO', 'ORDER'];
        $opcionais = ['CDFILICAIXA', 'CDCLIENTE', 'CDPRODUTO', 'CDPRODINI', 'CDPRODFIM', 'CDFILIAL'];
        $camposComT = ['TCDFILIAL', 'TCDFILICAIXA', 'TCDCLIENTE', 'TCDPRODUTO'];
        $camposPresentes = [];
        $parametros = [];
        
        $condicoes = $request->getFilterCriteria()->getConditions();
        
        foreach ($condicoes as $condicao) {
            if ($condicao['columnName'] === 'DTENTRVENDA') {
                $parametros['DTVENDAINI'] = $condicao['value'][0];
                $parametros['DTVENDAFIN'] = $condicao['value'][1];
                break;
            }
        }

        foreach ($condicoes as $condicao) {
            $camposPresentes[] = $condicao['columnName'];
        }
        
        $camposFaltantes = array_diff($obrigatorios, $camposPresentes);
        unset($camposPresentes);
        
        if (!empty($camposFaltantes)) {
            throw new Exception("Os campos obrigatórios faltantes são: " . implode(', ', $camposFaltantes));
        }
        unset($camposFaltantes);

        foreach (array_merge($obrigatorios, $opcionais) as $campo) {
            $valor = null;
            foreach ($condicoes as $condicao) {
                if ($condicao['columnName'] == $campo) {
                    if (in_array($campo, ['CDFILIAL', 'CDFILICAIXA', 'CDCLIENTE', 'CDPRODUTO'])) {
                        $valor = implode('_', array_map(function($item) {
                            return '_' . $item . '_';
                        }, $condicao['value']));
                    } else {
                        $valor = $condicao['value'];
                    }
                    break;
                }
            }
            $parametros[$campo] = $valor;
            
            // Verificar se o campo começa com 'T' e se o campo correspondente está vazio
            foreach ($camposComT as $campoT) {
                if (strpos($campoT, 'T' . strtoupper(substr($campo, 0, strlen($campo)))) !== false) {
                    if (!isset($parametros[$campo])) {
                        $parametros[$campoT] = 'T';
                    }else{
                        $parametros[$campoT] = null;
                    }
                }
            }
        }
        unset($condicoes);
        
        $result = $this->vendaServives->find($parametros);
        $response->addDataset(new DataSet('vendaProdutoPeriodo', $result));
    }
}